All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
XMPP::MUC::User Class Reference

`#include <xmpp_muc.h>`

Inheritance diagram for XMPP::MUC::User:

## Public Types

enum | Role { None, Moderator, Participant, Visitor, Unknown = 999 }
enum | Affiliation { None_a, Owner, Admin, Member, Outcast, Unknown_a = 999 }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| User ()
| ~User ()
Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static const PCaselessString & | NamespaceTag ()
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Public Attributes

PString | m_Nick
Role | m_Role
Affiliation | m_Affiliation

## Additional Inherited Members

Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Member Enumeration Documentation

enum XMPP::MUC::User::Affiliation

Enumerator
None_a |
Owner |
Admin |
Member |
Outcast |
Unknown_a |

enum XMPP::MUC::User::Role

Enumerator
None |
Moderator |
Participant |
Visitor |
Unknown |

## Constructor & Destructor Documentation

XMPP::MUC::User::User | ( |  | ) |

XMPP::MUC::User::~User | ( |  | ) |

## Member Function Documentation

Comparison XMPP::MUC::User::Compare | ( | const PObject & | obj | ) | const

virtual

Compare the two objects and return their relative rank.

This function is usually overridden by descendent classes to yield the ranking according to the semantics of the object.

The default function is to use the `CompareObjectMemoryDirect()` function to do a byte wise memory comparison of the two objects.

Returns
  `LessThan`, `EqualTo` or `GreaterThan` according to the relative rank of the objects.

Reimplemented from PObject.

static const PCaselessString& XMPP::MUC::User::NamespaceTag | ( |  | ) |

static

## Member Data Documentation

Affiliation XMPP::MUC::User::m_Affiliation

PString XMPP::MUC::User::m_Nick

Role XMPP::MUC::User::m_Role

The documentation for this class was generated from the following file:

- xmpp_muc.h